diff --git a/src/arch/linux/mapping/mapping.c b/src/arch/linux/mapping/mapping.c
index 7b6f9567f7..f04f1bd16c 100644
--- a/src/arch/linux/mapping/mapping.c
+++ b/src/arch/linux/mapping/mapping.c
@@ -114,12 +114,11 @@ void *dosaddr_to_unixaddr(unsigned int addr)
 
 void *physaddr_to_unixaddr(unsigned int addr)
 {
+  void *hwr = get_hardware_uaddr(addr);
+  if (hwr != MAP_FAILED)
+    return hwr;
   if (addr < LOWMEM_SIZE + HMASIZE)
     return dosaddr_to_unixaddr(addr);
-  if (addr < xms_base)
-    return LOWMEM(addr);
-  if (addr < xms_base + config.xms_map_size)
-    return xms_resolve_physaddr(addr);
   return MAP_FAILED;
 }
 
@@ -723,8 +722,8 @@ static void *alloc_mapping_kmem(int cap, size_t mapsize, off_t source)
     kmem_map[kmem_mappings].dst = -1;
     kmem_map[kmem_mappings].len = mapsize;
     kmem_mappings++;
-    Q_printf("MAPPING: region allocated at %p\n", addr);
-    return addr;
+    Q_printf("MAPPING: region allocated at %p\n", addr2);
+    return addr2;
 }
 #endif
 
@@ -783,6 +782,7 @@ struct hardware_ram {
   dosaddr_t vbase;
   size_t size;
   int type;
+  void *uaddr;
   struct hardware_ram *next;
 };
 
@@ -823,12 +823,12 @@ void init_hardware_ram(void)
 
   for (hw = hardware_ram; hw != NULL; hw = hw->next) {
     int cap = MAPPING_KMEM;
+    if (hw->uaddr)  /* virtual hardware ram mapped later */
+      continue;
     if (hw->default_vbase != (dosaddr_t)-1)
       cap |= MAPPING_LOWMEM;
-    if (hw->type == 'e')  /* virtual hardware ram mapped later */
-      continue;
 #ifdef __linux__
-    alloc_mapping_kmem(cap, hw->size, hw->base);
+    hw->uaddr = alloc_mapping_kmem(cap, hw->size, hw->base);
 #endif
     if (do_map_hwram(hw) == -1)
       return;
@@ -848,19 +848,6 @@ int map_hardware_ram(char type)
   return 0;
 }
 
-int map_hardware_ram_manual(size_t base, dosaddr_t vbase)
-{
-  struct hardware_ram *hw;
-
-  for (hw = hardware_ram; hw != NULL; hw = hw->next) {
-    if (hw->base != base)
-      continue;
-    hw->vbase = vbase;
-    return 0;
-  }
-  return -1;
-}
-
 int unmap_hardware_ram(char type)
 {
   struct hardware_ram *hw;
@@ -882,11 +869,12 @@ int unmap_hardware_ram(char type)
   return rc;
 }
 
-int register_hardware_ram(int type, dosaddr_t base, unsigned int size)
+static int do_register_hwram(int type, dosaddr_t base, unsigned size,
+	void *uaddr, dosaddr_t va)
 {
   struct hardware_ram *hw;
 
-  if (!can_do_root_stuff && type != 'e') {
+  if (!can_do_root_stuff && !uaddr) {
     dosemu_error("can't use hardware ram in low feature (non-suid root) DOSEMU\n");
     return 0;
   }
@@ -897,16 +885,45 @@ int register_hardware_ram(int type, dosaddr_t base, unsigned int size)
     hw->default_vbase = hw->base;
   else
     hw->default_vbase = -1;
-  hw->vbase = -1;
+  hw->vbase = va;
   hw->size = size;
   hw->type = type;
+  hw->uaddr = uaddr;
   hw->next = hardware_ram;
   hardware_ram = hw;
-  if (base >= LOWMEM_SIZE || type == 'h')
+  if (!uaddr && (base >= LOWMEM_SIZE || type == 'h'))
     memcheck_reserve(type, base, size);
   return 1;
 }
 
+int register_hardware_ram(int type, dosaddr_t base, unsigned int size)
+{
+  return do_register_hwram(type, base, size, NULL, -1);
+}
+
+int register_hardware_ram_virtual(int type, dosaddr_t base, unsigned int size,
+	void *uaddr, dosaddr_t va)
+{
+  return do_register_hwram(type, base, size, uaddr, va);
+}
+
+int unregister_hardware_ram_virtual(dosaddr_t base)
+{
+  struct hardware_ram *hw, *phw;
+
+  for (phw = NULL, hw = hardware_ram; hw != NULL; phw = hw, hw = hw->next) {
+    if (hw->base == base) {
+      if (phw)
+        phw->next = hw->next;
+      else
+        hardware_ram = hw->next;
+      free(hw);
+      return 0;
+    }
+  }
+  return -1;
+}
+
 /* given physical address addr, gives the corresponding vbase or -1 */
 unsigned get_hardware_ram(unsigned addr, uint32_t size)
 {
@@ -920,6 +937,18 @@ unsigned get_hardware_ram(unsigned addr, uint32_t size)
   return -1;
 }
 
+void *get_hardware_uaddr(unsigned addr)
+{
+  struct hardware_ram *hw;
+
+  for (hw = hardware_ram; hw != NULL; hw = hw->next) {
+    if (hw->vbase != -1 &&
+	hw->base <= addr && addr < hw->base + hw->size)
+      return hw->uaddr + addr - hw->base;
+  }
+  return MAP_FAILED;
+}
+
 void list_hardware_ram(void (*print)(const char *, ...))
 {
   struct hardware_ram *hw;
diff --git a/src/base/dev/vga/vgaemu.c b/src/base/dev/vga/vgaemu.c
index f13e492783..1f73f32c95 100644
--- a/src/base/dev/vga/vgaemu.c
+++ b/src/base/dev/vga/vgaemu.c
@@ -1703,7 +1703,8 @@ int vga_emu_pre_init(void)
 
   if(vga.mem.lfb_base != 0) {
     memcheck_addtype('e', "VGAEMU LFB");
-    register_hardware_ram('e', vga.mem.lfb_base, vga.mem.size);
+    register_hardware_ram_virtual('e', vga.mem.lfb_base, vga.mem.size,
+	    vga.mem.base, vga.mem.lfb_base);
   }
 
   return vga_emu_post_init();
@@ -1715,7 +1716,6 @@ static int vga_emu_post_init(void)
 
   if(vga.mem.lfb_base != 0) {
     vga.mem.lfb_base_page = vga.mem.lfb_base >> 12;
-    map_hardware_ram_manual(vga.mem.lfb_base, vga.mem.lfb_base);
   }
   vga_emu_setup_mode_table();
 
diff --git a/src/base/init/init.c b/src/base/init/init.c
index a1b4368fcf..7cfb2e87b6 100644
--- a/src/base/init/init.c
+++ b/src/base/init/init.c
@@ -387,6 +387,9 @@ void low_mem_init(void)
       config.exitearly = 1;
       return;
     }
+    /* memsize == base */
+    register_hardware_ram_virtual('m', memsize, EXTMEM_SIZE, lowmem + memsize,
+	    addr);
     x_printf("Ext.Mem of size 0x%x at %#x\n", EXTMEM_SIZE, addr);
   }
 
diff --git a/src/dosext/misc/xms.c b/src/dosext/misc/xms.c
index 7e3ba2776b..cdd4fa7a6d 100644
--- a/src/dosext/misc/xms.c
+++ b/src/dosext/misc/xms.c
@@ -270,17 +270,23 @@ static struct pava map_EMB(void *addr, unsigned size, unsigned handle)
     leavedos(2);
   }
   ret.pa = xms_base + (page << PAGE_SHIFT);
+  register_hardware_ram_virtual('x', ret.pa, size, addr, ret.va);
   return ret;
 }
 
 static void unmap_EMB(struct pava base, unsigned size)
 {
+  int err = unregister_hardware_ram_virtual(base.pa);
+  if (err)
+    error("error unregistering hwram at %#x\n", base.pa);
   /* don't unmap, just overmap with scratch page */
   mmap_mapping(MAPPING_OTHER | MAPPING_SCRATCH, base.va, PAGE_ALIGN(size),
         PROT_READ | PROT_WRITE);
   pgafree(pgapool, (base.pa - xms_base) >> PAGE_SHIFT);
 }
 
+#if 0
+/* unused */
 void *xms_resolve_physaddr(unsigned addr)
 {
   struct pgrm m;
@@ -292,6 +298,7 @@ void *xms_resolve_physaddr(unsigned addr)
   return (handles[m.id].addr + (m.pgoff << PAGE_SHIFT) +
       (addr & (PAGE_SIZE - 1)));
 }
+#endif
 
 static void do_free_EMB(int h)
 {
diff --git a/src/include/mapping.h b/src/include/mapping.h
index 19cfd78401..1dc6231747 100644
--- a/src/include/mapping.h
+++ b/src/include/mapping.h
@@ -119,10 +119,13 @@ void mapping_close(void);
 
 void init_hardware_ram(void);
 int map_hardware_ram(char type);
-int map_hardware_ram_manual(size_t base, dosaddr_t vbase);
 int unmap_hardware_ram(char type);
 int register_hardware_ram(int type, dosaddr_t base, unsigned size);
+int register_hardware_ram_virtual(int type, dosaddr_t base, unsigned size,
+    void *uaddr, dosaddr_t va);
+int unregister_hardware_ram_virtual(dosaddr_t base);
 unsigned get_hardware_ram(unsigned addr, uint32_t size);
+void *get_hardware_uaddr(unsigned addr);
 void list_hardware_ram(void (*print)(const char *, ...));
 void *mapping_find_hole(unsigned long start, unsigned long stop,
 	unsigned long size);
